<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <base data-ice="baseUrl" href="../../../">
  <title data-ice="title">src/utils/utils.unit.js | formiojs</title>
  <link type="text/css" rel="stylesheet" href="css/style.css">
  <link type="text/css" rel="stylesheet" href="css/prettify-tomorrow.css">
  <script src="script/prettify/prettify.js"></script>
  <script src="script/manual.js"></script>
<meta name="description" content="JavaScript powered Forms with JSON Form Builder"><meta property="twitter:card" content="summary"><meta property="twitter:title" content="formiojs"><meta property="twitter:description" content="JavaScript powered Forms with JSON Form Builder"></head>
<body class="layout-container" data-ice="rootContainer">

<header>
  <a href="./">Home</a>
  
  <a href="identifiers.html">Reference</a>
  <a href="source.html">Source</a>
  
  <div class="search-box">
  <span>
    <img src="./image/search.png">
    <span class="search-input-edge"></span><input class="search-input"><span class="search-input-edge"></span>
  </span>
    <ul class="search-result"></ul>
  </div>
<a href="https://gitlab.com/atorico.com/formio/formio.js.git">Repository</a></header>

<nav class="navigation" data-ice="nav"><div>
  <ul>
    
  <li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/EventEmitter.js~EventEmitter.html">EventEmitter</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/Form.js~Form.html">Form</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/FormBuilder.js~FormBuilder.html">FormBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/PDFBuilder.js~PDFBuilder.html">PDFBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/WizardBuilder.js~WizardBuilder.html">WizardBuilder</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-embed">embed</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#builders">builders</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/builders/Builders.js~Builders.html">Builders</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components">components</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/Components.js~Components.html">Components</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-component">components/_classes/component</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Component">Component</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-component-editform">components/_classes/component/editForm</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-EditFormUtils">EditFormUtils</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-componentmodal">components/_classes/componentModal</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/componentModal/ComponentModal.js~ComponentModal.html">ComponentModal</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-field">components/_classes/field</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/field/Field.js~Field.html">Field</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components--classes-nested">components/_classes/nested</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/_classes/nested/NestedComponent.js~NestedComponent.html">NestedComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-NestedComponent">NestedComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-address">components/address</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Address">Address</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-button">components/button</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Button">Button</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-checkbox">components/checkbox</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/checkbox/Checkbox.js~CheckBoxComponent.html">CheckBoxComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Checkbox">Checkbox</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-columns">components/columns</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/columns/Columns.js~ColumnsComponent.html">ColumnsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Columns">Columns</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-container">components/container</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/container/Container.js~ContainerComponent.html">ContainerComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Container">Container</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-content">components/content</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/content/Content.js~ContentComponent.html">ContentComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Content">Content</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-currency">components/currency</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/currency/Currency.js~CurrencyComponent.html">CurrencyComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Currency">Currency</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datagrid">components/datagrid</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DataGrid">DataGrid</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datamap">components/datamap</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/datamap/DataMap.js~DataMapComponent.html">DataMapComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DataMap">DataMap</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-datetime">components/datetime</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/datetime/DateTime.js~DateTimeComponent.html">DateTimeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-DateTime">DateTime</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-day">components/day</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Day">Day</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-editgrid">components/editgrid</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-EditGrid">EditGrid</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-email">components/email</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/email/Email.js~EmailComponent.html">EmailComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Email">Email</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-fieldset">components/fieldset</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/fieldset/Fieldset.js~FieldsetComponent.html">FieldsetComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Fieldset">Fieldset</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-file">components/file</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-File">File</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-form">components/form</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Form">Form</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-hidden">components/hidden</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/hidden/Hidden.js~HiddenComponent.html">HiddenComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Hidden">Hidden</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-html">components/html</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/html/HTML.js~HTMLComponent.html">HTMLComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-HTML">HTML</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-number">components/number</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/number/Number.js~NumberComponent.html">NumberComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Number">Number</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-panel">components/panel</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Panel">Panel</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-password">components/password</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/password/Password.js~PasswordComponent.html">PasswordComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Password">Password</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-phonenumber">components/phonenumber</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/phonenumber/PhoneNumber.js~PhoneNumberComponent.html">PhoneNumberComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-PhoneNumber">PhoneNumber</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-radio">components/radio</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/radio/Radio.js~RadioComponent.html">RadioComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Radio">Radio</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-recaptcha">components/recaptcha</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/recaptcha/ReCaptcha.js~ReCaptchaComponent.html">ReCaptchaComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-ReCaptcha">ReCaptcha</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-resource">components/resource</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/resource/Resource.js~ResourceComponent.html">ResourceComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Resource">Resource</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-select">components/select</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Select">Select</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-select-fixtures">components/select/fixtures</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-multiSelect">multiSelect</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-multiSelectOptions">multiSelectOptions</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-selectboxes">components/selectboxes</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-SelectBoxes">SelectBoxes</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-signature">components/signature</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/signature/Signature.js~SignatureComponent.html">SignatureComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Signature">Signature</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-survey">components/survey</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Survey">Survey</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-table">components/table</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/table/Table.js~TableComponent.html">TableComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Table">Table</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tabs">components/tabs</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tabs/Tabs.js~TabsComponent.html">TabsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tabs">Tabs</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tags">components/tags</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tags/Tags.js~TagsComponent.html">TagsComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tags">Tags</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-textarea">components/textarea</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-TextArea">TextArea</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-textfield">components/textfield</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-TextField">TextField</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-time">components/time</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/time/Time.js~TimeComponent.html">TimeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Time">Time</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-tree">components/tree</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/tree/Node.js~Node.html">Node</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Tree">Tree</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-unknown">components/unknown</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/unknown/Unknown.js~UnknownComponent.html">UnknownComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Unknown">Unknown</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-url">components/url</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/url/Url.js~UrlComponent.html">UrlComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Url">Url</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#components-well">components/well</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/components/well/Well.js~WellComponent.html">WellComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Well">Well</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib">contrib</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-Contrib">Contrib</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-edittable">contrib/edittable</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/edittable/EditTable.js~EditTableComponent.html">EditTableComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-EditTable">EditTable</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-location">contrib/location</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/location/Location.js~LocationComponent.html">LocationComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-Location">Location</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-modaledit">contrib/modaledit</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/modaledit/ModalEdit.js~ModalEditComponent.html">ModalEditComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-ModalEdit">ModalEdit</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-stripe-checkout">contrib/stripe/checkout</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/stripe/checkout/StripeCheckout.js~StripeCheckoutComponent.html">StripeCheckoutComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#contrib-stripe-stripe">contrib/stripe/stripe</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/contrib/stripe/stripe/Stripe.js~StripeComponent.html">StripeComponent</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#displays">displays</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/displays/Displays.js~Displays.html">Displays</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers">providers</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/Providers.js~Providers.html">Providers</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-address">providers/address</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/AddressProvider.js~AddressProvider.html">AddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/AzureAddressProvider.js~AzureAddressProvider.html">AzureAddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/CustomAddressProvider.js~CustomAddressProvider.html">CustomAddressProvider</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/providers/address/NominatimAddressProvider.js~NominatimAddressProvider.html">NominatimAddressProvider</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-processor">providers/processor</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-fileProcessor">fileProcessor</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#providers-storage">providers/storage</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-azure">azure</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-base64">base64</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-dropbox">dropbox</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-indexeddb">indexeddb</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-s3">s3</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getFormioUploadAdapterPlugin">getFormioUploadAdapterPlugin</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-url">url</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-setXhrHeaders">setXhrHeaders</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-XHR">XHR</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#templates">templates</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/templates/Templates.js~Templates.html">Templates</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#templates-bootstrap">templates/bootstrap</a><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-iconClass">iconClass</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#utils">utils</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/utils/ChoicesWrapper.js~ChoicesWrapper.html">ChoicesWrapper</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-checkInvalidDate">checkInvalidDate</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-lessOrGreater">lessOrGreater</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-applyFormChanges">applyFormChanges</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-eachComponent">eachComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-escapeRegExCharacters">escapeRegExCharacters</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-findComponent">findComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-findComponents">findComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-flattenComponents">flattenComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-formatAsCurrency">formatAsCurrency</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-generateFormChange">generateFormChange</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getComponent">getComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getStrings">getStrings</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-getValue">getValue</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-hasCondition">hasCondition</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-isLayoutComponent">isLayoutComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-matchComponent">matchComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-parseFloatExt">parseFloatExt</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-removeComponent">removeComponent</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-function">F</span><span data-ice="name"><span><a href="function/index.html#static-function-searchComponents">searchComponents</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-KEY_CODES">KEY_CODES</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-Evaluator">Evaluator</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-CALENDAR_ERROR_MESSAGES">CALENDAR_ERROR_MESSAGES</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#utils-jsonlogic">utils/jsonlogic</a><span data-ice="kind" class="kind-variable">V</span><span data-ice="name"><span><a href="variable/index.html#static-variable-lodashOperators">lodashOperators</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#validator">validator</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/validator/Rules.js~Rules.html">Rules</a></span></span></li>
<li data-ice="doc"><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/validator/Validator.js~ValidationChecker.html">ValidationChecker</a></span></span></li>
<li data-ice="doc"><a data-ice="dirPath" class="nav-dir-path" href="identifiers.html#widgets">widgets</a><span data-ice="kind" class="kind-class">C</span><span data-ice="name"><span><a href="class/src/widgets/InputWidget.js~InputWidget.html">InputWidget</a></span></span></li>
</ul>
</div>
</nav>

<div class="content" data-ice="content"><h1 data-ice="title">src/utils/utils.unit.js</h1>
<pre class="source-code line-number raw-source-code"><code class="prettyprint linenums" data-ice="content">import * as fs from &apos;fs&apos;;
import { expect, assert } from &apos;chai&apos;;
import _ from &apos;lodash&apos;;
import writtenNumber from &apos;written-number&apos;;
import utils from &apos;.&apos;;
const components = JSON.parse(fs.readFileSync(&apos;src/utils/fixtures/components.json&apos;));
const components2 = JSON.parse(fs.readFileSync(&apos;src/utils/fixtures/components2.json&apos;));
const components3 = JSON.parse(fs.readFileSync(&apos;src/utils/fixtures/components3.json&apos;));
const components4 = JSON.parse(fs.readFileSync(&apos;src/utils/fixtures/components4.json&apos;));
const components5 = JSON.parse(fs.readFileSync(&apos;src/utils/fixtures/components5.json&apos;));
const submission1 = JSON.parse(fs.readFileSync(&apos;src/utils/fixtures/submission1.json&apos;));

describe(&apos;Util Tests&apos;, () =&gt; {
  describe(&apos;eachComponent&apos;, () =&gt; {
    it(&apos;should iterate through nested components in the right order&apos;, () =&gt; {
      let n = 1;
      utils.eachComponent(components, (component) =&gt; {
        expect(component.order).to.equal(n);
        n += 1;
      });
    });

    it(&apos;should include layouts components if provided&apos;, () =&gt; {
      let numComps = 0;
      let numLayout = 0;
      utils.eachComponent(components, (component) =&gt; {
        if (utils.isLayoutComponent(component)) {
          numLayout++;
        }
        else {
          numComps++;
        }
      }, true);
      expect(numLayout).to.be.equal(3);
      expect(numComps).to.be.equal(8);
    });

    it(&apos;Should provide the paths to all of the components&apos;, () =&gt; {
      const paths = [
        &apos;one&apos;,
        &apos;parent1&apos;,
        &apos;two&apos;,
        &apos;parent2&apos;,
        &apos;three&apos;,
        &apos;&apos;,
        &apos;four&apos;,
        &apos;five&apos;,
        &apos;six&apos;,
        &apos;seven&apos;,
        &apos;eight&apos;
      ];
      const testPaths = [];
      utils.eachComponent(components, (component, path) =&gt; {
        testPaths.push(path);
      }, true);
      expect(paths).to.deep.equal(testPaths);
    });

    describe(&apos;findComponent&apos;, () =&gt; {
      it(&apos;should find correct component in nested structure&apos;, () =&gt; {
        utils.findComponent(components4, &apos;four&apos;, null, (component) =&gt; {
          expect(component.label).to.equal(&apos;4&apos;);
        });
      });
      it(&apos;should find correct component in flat structure&apos;, () =&gt; {
        utils.findComponent(components4, &apos;one&apos;, null, (component) =&gt; {
          expect(component.label).to.equal(&apos;1&apos;);
        });
      });
    });

    it(&apos;Should be able to find all textfield components&apos;, () =&gt; {
      const comps = utils.findComponents(components, { type: &apos;textfield&apos; });
      expect(comps.length).to.equal(6);
    });

    it(&apos;Should be able to find components with special properties.&apos;, () =&gt; {
      const comps = utils.findComponents(components3, { &apos;properties.path&apos;: &apos;a&apos; });
      expect(comps.length).to.equal(4);
      expect(comps[0].key).to.equal(&apos;b&apos;);
      expect(comps[1].key).to.equal(&apos;e&apos;);
      expect(comps[2].key).to.equal(&apos;j&apos;);
      expect(comps[3].key).to.equal(&apos;m&apos;);
    });

    it(&apos;Should be able to generate paths based on component types&apos;, () =&gt; {
      const paths = [
        &apos;a&apos;,
        &apos;b&apos;,
        &apos;c&apos;,
        &apos;d&apos;,
        &apos;f&apos;,
        &apos;f.g&apos;,
        &apos;f.h&apos;,
        &apos;f.i&apos;,
        &apos;e&apos;,
        &apos;j&apos;,
        &apos;k&apos;,
        &apos;k.n&apos;,
        &apos;k.n.o&apos;,
        &apos;k.n.p&apos;,
        &apos;k.n.q&apos;,
        &apos;k.m&apos;,
        &apos;k.l&apos;,
        &apos;r&apos;,
        &apos;submit&apos;
      ];
      const testPaths = [];
      utils.eachComponent(components2, (component, path) =&gt; {
        testPaths.push(path);
      }, true);
      expect(paths).to.deep.equal(testPaths);
    });

    it(&apos;Should still provide the correct paths when it is not recursive&apos;, () =&gt; {
      const paths = [
        &apos;a&apos;,
        &apos;d&apos;,
        &apos;f&apos;,
        &apos;f.g&apos;,
        &apos;f.h&apos;,
        &apos;f.i&apos;,
        &apos;e&apos;,
        &apos;j&apos;,
        &apos;k&apos;,
        &apos;k.n&apos;,
        &apos;k.n.o&apos;,
        &apos;k.n.p&apos;,
        &apos;k.n.q&apos;,
        &apos;k.m&apos;,
        &apos;k.l&apos;,
        &apos;r&apos;,
        &apos;submit&apos;
      ];
      const testPaths = [];
      utils.eachComponent(components2, (component, path) =&gt; {
        testPaths.push(path);
      });
      expect(paths).to.deep.equal(testPaths);
    });

    it(&apos;should be able to block recursion&apos;, () =&gt; {
      let numComps = 0;
      let numLayout = 0;
      utils.eachComponent(components, (component) =&gt; {
        if (utils.isLayoutComponent(component)) {
          numLayout++;
        }
        else {
          numComps++;
        }

        if (component.type === &apos;table&apos;) {
          let numInTable = 0;
          [].concat.apply([], component.rows).forEach((row) =&gt; {
            utils.eachComponent(row.components, () =&gt; {
              numInTable++;
            });
          });
          expect(numInTable).to.be.equal(4);
          return true;
        }
      }, true);
      expect(numLayout).to.be.equal(3);
      expect(numComps).to.be.equal(4);
    });

    it(&apos;should not include `htmlelement` components when `includeAll` is not provided&apos;, () =&gt; {
      let htmlComponentsAmount = 0;
      utils.eachComponent(components5, (component) =&gt; {
        if (component.type === &apos;htmlelement&apos;) {
          htmlComponentsAmount++;
        }
      });
      expect(htmlComponentsAmount).to.be.equal(0);
    });

    it(&apos;should include `htmlelement` components when `includeAll` is provided&apos;, () =&gt; {
      let htmlComponentsAmount = 0;
      utils.eachComponent(components5, (component) =&gt; {
        if (component.type === &apos;htmlelement&apos;) {
          htmlComponentsAmount++;
        }
      }, true);
      expect(htmlComponentsAmount).to.be.equal(1);
    });

    it(&apos;should not include `content` components when `includeAll` is not provided&apos;, () =&gt; {
      let contentComponentsAmount = 0;
      utils.eachComponent(components5, (component) =&gt; {
        if (component.type === &apos;content&apos;) {
          contentComponentsAmount++;
        }
      });
      expect(contentComponentsAmount).to.be.equal(0);
    });

    it(&apos;should include `content` components when `includeAll` is provided&apos;, () =&gt; {
      let contentComponentsAmount = 0;
      utils.eachComponent(components5, (component) =&gt; {
        if (component.type === &apos;content&apos;) {
          contentComponentsAmount++;
        }
      }, true);
      expect(contentComponentsAmount).to.be.equal(1);
    });
  });

  describe(&apos;getComponent&apos;, () =&gt; {
    it(&apos;should return the correct components&apos;, () =&gt; {
      for (let n = 1; n &lt;= 8; n += 1) {
        const component = utils.getComponent(components, writtenNumber(n));
        expect(component).not.to.be.null;
        expect(component).not.to.be.undefined;
        expect(component).to.be.an(&apos;object&apos;);
        expect(component.order).to.equal(n);
        expect(component.key).to.equal(writtenNumber(n));
      }
    });

    it(&apos;should work with a different this context&apos;, () =&gt; {
      for (let n = 1; n &lt;= 8; n += 1) {
        const component = utils.getComponent.call({}, components, writtenNumber(n));
        expect(component).not.to.be.null;
        expect(component).not.to.be.undefined;
        expect(component).to.be.an(&apos;object&apos;);
        expect(component.order).to.equal(n);
        expect(component.key).to.equal(writtenNumber(n));
      }
    });
  });

  describe(&apos;flattenComponents&apos;, () =&gt; {
    it(&apos;should return an object of flattened components&apos;, () =&gt; {
      const flattened = utils.flattenComponents(components);
      for (let n = 1; n &lt;= 8; n += 1) {
        const component = flattened[writtenNumber(n)];
        expect(component).not.to.be.undefined;
        expect(component).to.be.an(&apos;object&apos;);
        expect(component.order).to.equal(n);
        expect(component.key).to.equal(writtenNumber(n));
      }
    });

    it(&apos;should work with a different this context&apos;, () =&gt; {
      const flattened = utils.flattenComponents.call({}, components);
      for (let n = 1; n &lt;= 8; n += 1) {
        const component = flattened[writtenNumber(n)];
        expect(component).not.to.be.undefined;
        expect(component).to.be.an(&apos;object&apos;);
        expect(component.order).to.equal(n);
        expect(component.key).to.equal(writtenNumber(n));
      }
    });
  });

  describe(&apos;getValue&apos;, () =&gt; {
    it(&apos;should be able to get a simple value&apos;, () =&gt; {
      expect(utils.getValue(submission1, &apos;name&apos;)).to.be.equal(submission1.data.name);
    });

    it(&apos;should be able to get a value from a container&apos;, () =&gt; {
      expect(utils.getValue(submission1, &apos;animalname&apos;)).to.be.equal(submission1.data.mycontainer.animalname);
    });
  });

  describe(&apos;parseFloat&apos;, () =&gt; {
    it(&apos;should clear input and parse value&apos;, () =&gt; {
      expect(utils.parseFloatExt(&apos;12,345,678.90&apos;)).to.be.equal(12345678.90);
    });
  });

  describe(&apos;formatAsCurrency&apos;, () =&gt; {
    it(&apos;should be able to format Float value for Currency component&apos;, () =&gt; {
      expect(utils.formatAsCurrency(123.4)).to.be.equal(&apos;123.40&apos;);
      expect(utils.formatAsCurrency(12345678.9)).to.be.equal(&apos;12,345,678.90&apos;);
      expect(utils.formatAsCurrency(12345678.915)).to.be.equal(&apos;12,345,678.92&apos;);
    });

    it(&apos;should be able to format String value for Currency component&apos;, () =&gt; {
      expect(utils.formatAsCurrency(&apos;12345678.915&apos;)).to.be.equal(&apos;12,345,678.92&apos;);
    });
  });

  describe(&apos;checkCalculated&apos;, () =&gt; {
    it(&apos;should be able to calculate value based on javascript code&apos;, () =&gt; {
      const component = {
        key: &apos;sum&apos;,
        calculateValue: &apos;value = 3&apos;
      };
      const data = {};

      utils.checkCalculated(component, null, data);
      expect(data.sum).to.be.equal(3);
    });

    it(&apos;should be able to calculate value based on json logic&apos;, () =&gt; {
      const component = {
        key: &apos;sum&apos;,
        calculateValue: {
          &apos;_sum&apos;: { var: &apos;data.test&apos; }
        }
      };
      const data = { test: [1, 2, 3] };

      utils.checkCalculated(component, null, data);
      expect(data.sum).to.be.equal(6);
    });

    it(&apos;should return undefined if no logic provided&apos;, () =&gt; {
      const component = {
        key: &apos;sum&apos;,
        calculateValue: &apos;/* do nothing */&apos;
      };
      const data = {};

      utils.checkCalculated(component, null, data);
      expect(data.sum).to.be.undefined;
    });
  });

  describe(&apos;checkCondition&apos;, () =&gt; {
    it(&apos;should display component by default&apos;, () =&gt; {
      expect(utils.checkCondition({}, null, {})).to.be.equal(true);
    });

    it(&apos;should calculate simple triggers&apos;, () =&gt; {
      const component = {
        key: &apos;sum&apos;,
        conditional: {
          when: &apos;test&apos;,
          eq: 3,
          show: true
        }
      };
      const data1 = { test: 3 };
      const data2 = { test: 5 };
      expect(utils.checkCondition(component, null, data1)).to.be.equal(true);
      expect(utils.checkCondition(component, null, data2)).to.be.equal(false);
    });

    it(&apos;should be able to calculate condition based on javascript code&apos;, () =&gt; {
      const component = {
        key: &apos;sum&apos;,
        customConditional(context) {
          return context.data.test === 3;
        }
      };
      const data1 = { test: 3 };
      const data2 = { test: 5 };

      expect(utils.checkCondition(component, null, data1)).to.be.equal(true);
      expect(utils.checkCondition(component, null, data2)).to.be.equal(false);
    });

    it(&apos;should be able to calculate condition based on json logic&apos;, () =&gt; {
      const component = {
        key: &apos;sum&apos;,
        conditional: {
          json: {
            &apos;===&apos;: [
              { &apos;_sum&apos;: { var: &apos;data.test&apos; } },
              6
            ]
          }
        }
      };
      const data1 = { test: [1, 2, 3] };
      const data2 = { test: [1, 2, 4] };

      expect(utils.checkCondition(component, null, data1)).to.be.equal(true);
      expect(utils.checkCondition(component, null, data2)).to.be.equal(false);
    });
  });

  describe(&apos;getDateSetting&apos;, () =&gt; {
    it(&apos;should return null if no date provided&apos;, () =&gt; {
      expect(utils.getDateSetting()).to.be.equal(null);
      expect(utils.getDateSetting(null)).to.be.equal(null);
      expect(utils.getDateSetting(undefined)).to.be.equal(null);
      expect(utils.getDateSetting(NaN)).to.be.equal(null);
      expect(utils.getDateSetting(&apos;&apos;)).to.be.equal(null);
      expect(utils.getDateSetting(&apos;should be invalid&apos;)).to.be.equal(null);
    });

    it(&apos;should return valid Date on serialized date provided&apos;, () =&gt; {
      const date = new Date(0);
      expect(utils.getDateSetting(date)).to.be.eql(date);
      expect(utils.getDateSetting(date.valueOf())).to.be.eql(date);
      expect(utils.getDateSetting(date.toString())).to.be.eql(date);
      expect(utils.getDateSetting(date.toISOString())).to.be.eql(date);
    });

    it(&apos;should be able to get value using moment APIs&apos;, () =&gt; {
      const validMomentExpression = &apos;moment(0)&apos;;
      const validDate = new Date(0);
      const invalidMomentExpression = &quot;moment(&apos;&apos;)&quot;;

      expect(utils.getDateSetting(validMomentExpression)).to.be.eql(validDate);
      expect(utils.getDateSetting(invalidMomentExpression)).to.be.equal(null);
    });
  });

  describe(&apos;checkTrigger&apos;, () =&gt; {
    it(&apos;should default to false&apos;, () =&gt; {
      expect(utils.checkCondition({}, { type: &apos;none&apos; }, null, {})).to.be.equal(true);
    });

    it(&apos;should calculate simple triggers&apos;, () =&gt; {
      const component = {
        key: &apos;sum&apos;
      };
      const trigger = {
        type: &apos;simple&apos;,
        simple: {
          when: &apos;test&apos;,
          eq: 3,
          show: true
        }
      };
      const data1 = { test: 3 };
      const data2 = { test: 5 };
      expect(utils.checkTrigger(component, trigger, null, data1)).to.be.equal(true);
      expect(utils.checkTrigger(component, trigger, null, data2)).to.be.equal(false);
    });

    it(&apos;should be able to calculate trigger based on javascript code&apos;, () =&gt; {
      const component = {
        key: &apos;sum&apos;
      };
      const trigger = {
        type: &apos;javascript&apos;,
        javascript: &apos;result = data.test === 3&apos;
      };
      const data1 = { test: 3 };
      const data2 = { test: 5 };

      expect(utils.checkTrigger(component, trigger, null, data1)).to.be.equal(true);
      expect(utils.checkTrigger(component, trigger, null, data2)).to.be.equal(false);
    });

    it(&apos;should be able to calculate trigger based on json logic&apos;, () =&gt; {
      const component = {
        key: &apos;sum&apos;
      };
      const trigger = {
        type: &apos;json&apos;,
        json: {
          &apos;===&apos;: [
            { &apos;_sum&apos;: { var: &apos;data.test&apos; } },
            6
          ]
        }
      };
      const data1 = { test: [1, 2, 3] };
      const data2 = { test: [1, 2, 4] };

      expect(utils.checkTrigger(component, trigger, null, data1)).to.be.equal(true);
      expect(utils.checkTrigger(component, trigger, null, data2)).to.be.equal(false);
    });
  });

  describe(&apos;setActionProperty&apos;, () =&gt; {
    it(&apos;should set a boolean action property to true&apos;, () =&gt; {
      const component = {
        key: &apos;test&apos;,
        disabled: false,
      };
      const action = {
        type: &apos;property&apos;,
        property: {
          label: &apos;Disabled&apos;,
          value: &apos;disabled&apos;,
          type: &apos;boolean&apos;,
        },
        state: true,
      };

      utils.setActionProperty(component, action);

      expect(component.disabled).to.be.equal(true);
    });

    it(&apos;should set a boolean action property to false&apos;, () =&gt; {
      const component = {
        key: &apos;test&apos;,
        disabled: true,
      };
      const action = {
        type: &apos;property&apos;,
        property: {
          label: &apos;Disabled&apos;,
          value: &apos;disabled&apos;,
          type: &apos;boolean&apos;,
        },
        state: false,
      };

      utils.setActionProperty(component, action);

      expect(component.disabled).to.be.equal(false);
    });

    it(&apos;should set a boolean action nested property&apos;, () =&gt; {
      const component = {
        key: &apos;test&apos;,
        validate: {
          required: true,
        },
      };
      const action = {
        type: &apos;property&apos;,
        property: {
          label: &apos;Required&apos;,
          value: &apos;validate.required&apos;,
          type: &apos;boolean&apos;,
        },
        state: false,
      };

      utils.setActionProperty(component, action);

      expect(component.validate.required).to.be.equal(false);
    });

    it(&apos;should set a string action property&apos;, () =&gt; {
      const component = {
        key: &apos;test&apos;,
        label: &apos;foo&apos;,
      };
      const action = {
        type: &apos;property&apos;,
        property: {
          label: &apos;Label&apos;,
          value: &apos;label&apos;,
          type: &apos;string&apos;,
        },
        text: &apos;bar&apos;,
      };

      utils.setActionProperty(component, action);

      expect(component.label).to.be.equal(&apos;bar&apos;);
    });

    it(&apos;should set a string action property with result templating&apos;, () =&gt; {
      const component = {
        key: &apos;test&apos;,
        label: &apos;foo&apos;,
      };
      const action = {
        type: &apos;property&apos;,
        property: {
          label: &apos;Label&apos;,
          value: &apos;label&apos;,
          type: &apos;string&apos;,
        },
        text: &apos;bar {{ result }}&apos;,
      };

      utils.setActionProperty(component, action, &apos;baz&apos;);

      expect(component.label).to.be.equal(&apos;bar baz&apos;);
    });

    it(&apos;should set a string action property with row templating&apos;, () =&gt; {
      const component = {
        key: &apos;test&apos;,
        label: &apos;foo&apos;,
      };
      const action = {
        type: &apos;property&apos;,
        property: {
          label: &apos;Label&apos;,
          value: &apos;label&apos;,
          type: &apos;string&apos;,
        },
        text: &apos;bar {{ row.field }}&apos;,
      };

      utils.setActionProperty(component, action, true, { field: &apos;baz&apos; });

      expect(component.label).to.be.equal(&apos;bar baz&apos;);
    });

    it(&apos;should set a string action property with data templating&apos;, () =&gt; {
      const component = {
        key: &apos;test&apos;,
        label: &apos;foo&apos;,
      };
      const action = {
        type: &apos;property&apos;,
        property: {
          label: &apos;Label&apos;,
          value: &apos;label&apos;,
          type: &apos;string&apos;,
        },
        text: &apos;bar {{ data.field }}&apos;,
      };

      utils.setActionProperty(component, action, true, {}, { field: &apos;baz&apos; });

      expect(component.label).to.be.equal(&apos;bar baz&apos;);
    });

    it(&apos;should set a string action property with component templating&apos;, () =&gt; {
      const component = {
        key: &apos;test&apos;,
        label: &apos;foo&apos;,
      };
      const action = {
        type: &apos;property&apos;,
        property: {
          label: &apos;Label&apos;,
          value: &apos;label&apos;,
          type: &apos;string&apos;,
        },
        text: &apos;bar {{ component.key }}&apos;,
      };

      utils.setActionProperty(component, action);

      expect(component.label).to.be.equal(&apos;bar test&apos;);
    });

    it(&apos;should do nothing with a bad request&apos;, () =&gt; {
      const component = {
        key: &apos;test&apos;,
        label: &apos;foo&apos;,
      };
      const originalComponent = _.cloneDeep(component);

      expect(component).to.deep.equal(originalComponent);
    });
  });

  describe(&apos;delay&apos;, () =&gt; {
    let score = 0;

    function incScore(value) {
      score += value || 1;
    }

    beforeEach(() =&gt; {
      score = 0;
    });

    it(&apos;should act as regular setTimeout()&apos;, (done) =&gt; {
      utils.delay(incScore);
      utils.delay(incScore, 0);
      utils.delay(incScore, 100, 2);
      utils.delay(() =&gt; {
        if (score === 4) {
          done();
        }
      }, 200);
    });

    it(&apos;should be cancelable via direct timer access&apos;, (done) =&gt; {
      const delay = utils.delay(incScore);
      clearTimeout(delay.timer);
      setTimeout(() =&gt; {
        if (score === 0) {
          done();
        }
      }, 100);
    });

    it(&apos;should be cancelable via cancel() method&apos;, (done) =&gt; {
      const delay = utils.delay(incScore);
      delay.cancel();
      setTimeout(() =&gt; {
        if (score === 0) {
          done();
        }
      }, 100);
    });

    it(&apos;should be able to call passed function synchronously&apos;, (done) =&gt; {
      const delay = utils.delay(incScore);
      delay();
      if (score === 1) {
        done();
      }
    });
  });

  describe(&apos;withSwitch&apos;, () =&gt; {
    it(&apos;should return Array with two functions&apos;, () =&gt; {
      const fns = utils.withSwitch();

      expect(fns).to.be.an(&apos;array&apos;).and.have.lengthOf(2);
      expect(fns[0]).to.be.a(&apos;function&apos;);
      expect(fns[1]).to.be.a(&apos;function&apos;);
    });

    describe(&apos;#get&apos;, () =&gt; {
      it(&apos;should return one of state&apos;, () =&gt; {
        const [get] = utils.withSwitch(42, 24);
        expect(get()).to.be.equal(42);
      });

      it(&apos;should be pure&apos;, () =&gt; {
        const [get] = utils.withSwitch(42, 24);
        expect(get()).to.be.equal(42);
        expect(get()).to.be.equal(42);
        expect(get()).to.be.equal(42);
        expect(get()).to.be.equal(42);
      });
    });

    describe(&apos;#toggle&apos;, () =&gt; {
      it(&apos;should cycle between states&apos;, () =&gt; {
        const [get, toggle] = utils.withSwitch(42, 24);
        expect(get()).to.be.equal(42);
        toggle();
        expect(get()).to.be.equal(24);
        toggle();
        expect(get()).to.be.equal(42);
      });
    });
  });

  describe(&apos;unfold&apos;, () =&gt; {
    it(&apos;should return provided argument&apos;, () =&gt; {
      const parameters = [{}, 1, null, &apos;string&apos;];

      parameters.forEach(p =&gt; {
        assert(p === utils.unfold(p));
      });
    });

    it(&apos;should call parameter, if it is function and return result&apos;, () =&gt; {
      const x = Symbol(&apos;__unfold__&apos;);
      assert(utils.unfold(() =&gt; x) === x);
    });
  });

  describe(&apos;firstNonNil&apos;, () =&gt; {
    it(&apos;should return first non nil value&apos;, () =&gt; {
      expect(utils.firstNonNil([1])).to.equal(1);
      expect(utils.firstNonNil([1, 3])).to.equal(1);
      expect(utils.firstNonNil([3, 2, 1])).to.equal(3);
      expect(utils.firstNonNil([undefined, undefined, 3, 1])).to.equal(3);
    });
    it(&apos;should unfold all functions in array&apos;, () =&gt; {
      expect(utils.firstNonNil([() =&gt; 1])).to.equal(1);
      expect(utils.firstNonNil([() =&gt; 1, 3])).to.equal(1);
      expect(utils.firstNonNil([undefined, undefined, () =&gt; 3, 1])).to.equal(3);
    });
  });

  describe(&apos;observeOverload&apos;, () =&gt; {
    it(&apos;should invoke the callback, if there too many dispatches in a short time&apos;, done =&gt; {
      try {
        const dispatch = utils.observeOverload(() =&gt; true);

        for (let i = 0; i &lt; 100; i += 1) {
          if (dispatch()) {
            return done();
          }
        }

        throw new Error(&apos;Callback not called&apos;);
      }
      catch (error) {
        done(error);
      }
    });

    it(&apos;should allow configuring the events limit&apos;, done =&gt; {
      try {
        for (let i = 1; i &lt; 10; i += 1) {
          const dispatch = utils.observeOverload(() =&gt; done(&apos;Limit option is ignored1&apos;), { limit: 100 });
          for (let j = 0; j &lt; i * 10; j += 1) {
            dispatch();
          }
        }

        // exit if we done, otherwise throw
        let called = false;
        const dispatch = utils.observeOverload(() =&gt; {
          called = true;
          done();
        }, { limit: 100 });

        for (let i = 0; i &lt; 110; i += 1) {
          dispatch();
        }

        if (!called) {
          throw new Error(&apos;Limit option is ignored2&apos;);
        }
      }
      catch (error) {
        done(error);
      }
    });

    it(&apos;should not invoke callback, if time between calls longer then options.delay&apos;, done =&gt; {
      try {
        const dispatch = utils.observeOverload(() =&gt; done(&apos;Callback should not be called&apos;), { delay: 100, limit: 2 });
        let count = 0;

        const id = setInterval(() =&gt; {
          dispatch();
          count += 1;
          if (count &gt;= 3) {
            done();
            clearInterval(id);
          }
        }, 110);
      }
      catch (error) {
        done(error);
      }
    });

    it(&apos;Should return string without HTML characters&apos;, () =&gt; {
      const unescapedString = utils.unescapeHTML(&apos;&amp;lt;p&amp;gt;ampersand &amp;amp; &amp;#34;quotes&amp;#34; test&amp;lt;&amp;#47;p&amp;gt;&apos;);
      expect(unescapedString).to.equal(&apos;&lt;p&gt;ampersand &amp; &quot;quotes&quot; test&lt;/p&gt;&apos;);
    });
  });
});
</code></pre>

</div>

<footer class="footer">
  Generated by <a href="https://esdoc.org">ESDoc<span data-ice="esdocVersion">(1.1.0)</span><img src="./image/esdoc-logo-mini-black.png"></a>
</footer>

<script src="script/search_index.js"></script>
<script src="script/search.js"></script>
<script src="script/pretty-print.js"></script>
<script src="script/inherited-summary.js"></script>
<script src="script/test-summary.js"></script>
<script src="script/inner-link.js"></script>
<script src="script/patch-for-local.js"></script>
</body>
</html>
